/* 
	UnLoopGraphs.java

	Title:			Kontsevich graph homology calculator
                                PhD thesis, Cornell University, Aug 2002
	Author:			Ferenc Gerlits
	Description:	selecting trivalent graphs without loops
	                  or other odd automorphisms
*/

package Konts;

import java.util.Vector;
import java.io.*;

public class UnLoopGraphs 
{
  public static void main (String args[]) throws IOException {
    int i, j, nv, nall, ngood;
    Graph g;
    
    if (args.length != 2) {
      System.out.println("Usage: UnLoopGraphs inputlist outputlist.");
      System.exit(1);
      }
    
    nall = ngood = 0;   // number of graphs processed
    
    FileInputStream infs = null;
    ObjectInputStream ins;
    infs = new FileInputStream(args[0]);
    ins = new ObjectInputStream(infs);
    FileOutputStream outfs = new FileOutputStream(args[1]);
    ObjectOutputStream outs = new ObjectOutputStream(outfs);
    try {
      while (true) {
        g = (Graph)ins.readObject();
        nall++;
        if (g.noLoops == 0) {
          outs.writeObject(g);
          ngood++;
          }
        }
      }
      catch(EOFException e) { }
      catch (ClassNotFoundException e) {
        System.out.println("Class not found.");
        System.exit(1);
        }
    
    outs.close();  outfs.close();
    ins.close();  infs.close();
    
    System.out.println(nall + " graphs read, "+ ngood + " graphs "+
                      "written at " + new java.util.Date() + ".");
    }
}
