/* 
	WritePS.java

	Title:			Kontsevich graph homology calculator
                                PhD thesis, Cornell University, Aug 2002
	Author:			Ferenc Gerlits
	Description:	produces a postscript file from a Graph list
*/

package Konts;

import java.util.Vector;
import java.io.*;

public class WritePS
{
  public static void main(String argv[]) throws java.io.IOException {
    int n, i,j;
    Graph g;
    Vector bag = new Vector(10,10);
    FileInputStream fs = null;
    ObjectInputStream s = null;
        
    fs = new FileInputStream(argv[0]);             
    s = new ObjectInputStream(fs);

    System.out.println("%!PS");
    System.out.println("(drawgraphs.ps) run");
    System.out.println();                // #include header file
    System.out.println("[");
    System.out.println();

    try {
      n = 0;
      while (true) {
        g = (Graph)s.readObject();
        System.out.println("[");
        System.out.print(g);
        System.out.println("]");
System.out.println("% "+g.noLoops+","+g.noMultiples+","+g.noTriangles
                       +"; "+g.coeff);
        System.out.println();
        }
      }
    catch(EOFException e) {}  
    catch (ClassNotFoundException e) {
      System.out.println("Class not found.");
      System.exit(1);
      }
     
    s.close();
    fs.close();

    System.out.println("] drawgraphs showpage");
    }
}
